Subject: bug#61954: 30.0.50; [PATCH] Simplify structured commands in Eshell

From: Sean Whitton <[email-masked]>
Date: Sun, 05 Mar 2023 18:15:54 -0700

Hello,

On Fri 03 Mar 2023 at 11:28PM -08, Jim Porter wrote:

> Structured commands are just Eshell flow control commands, like 'if' and
> 'while'. These expected you to set 'eshell-test-body' and
> 'eshell-command-body' when implementing them, and were very hard to get right
> (see bug#12571 for example).
>
> Instead, let's improve Eshell's iterative command evaluation some more so that
> you can write the implementations for these commands like normal. I think this
> is beneficial for two main reasons: a) it should get us closer to replacing
> Eshell's iterative evaluation with the CPS machinery in generator.el
> (bug#37635)[1], and b) third-parties should have an easier time writing their
> own fancy Eshell commands using the command-rewriting hooks.

I think you have typo'd the bug number?

I would like to read about what the advantages of moving to CPS in
particular will be.  My understanding was that CPS is only rarely a good
idea.

-- 
Sean Whitton